## mingw-w64-waf-2.0.25-2.src.tar.zst

=== demos/asm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys

def configure(conf):
	conf.load('gcc gas')
	try:
		size = sys.maxint
	except AttributeError:
		size = sys.maxsize # python 3.2
	if size < 4**21:
		conf.fatal('this example is for 64-bit systems only')

def build(bld):
	# https://waf.io/apidocs/tools/asm.html
	bld.program(
		source   = 'main.c test.S',
		target   = 'asmtest',
		defines  = 'foo=12',
		asflags  = '-Os',
		includes = '.')

	def disp(ctx):
		node = ctx.bldnode.ant_glob('asmtest*', remove=False)[0]
		ctx.exec_command('%s' % node.abspath(), shell=False)
	bld.add_post_fun(disp)

=== demos/c++/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006-2010 (ita)

# the following two variables are used by the target "waf dist"
VERSION='0.0.1'
APPNAME='cxx_test'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx')

def configure(conf):
	conf.load('compiler_cxx')
	conf.check(header_name='stdio.h', features='cxx cxxprogram', mandatory=False)

def build(bld):
	bld.shlib(source='a.cpp', target='mylib', vnum='9.8.7')
	bld.shlib(source='a.cpp', target='mylib2', vnum='9.8.7', cnum='9.8')
	bld.shlib(source='a.cpp', target='mylib3')
	bld.program(source='main.cpp', target='app', use='mylib')
	bld.stlib(target='foo', source='b.cpp')

	# just a test to check if the .c is compiled as c++ when no c compiler is found
	bld.program(features='cxx cxxprogram', source='main.c', target='app2')

	if bld.cmd != 'clean':
		from waflib import Logs
		bld.logger = Logs.make_logger('test.log', 'build') # just to get a clean output
		bld.check(header_name='sadlib.h', features='cxx cxxprogram', mandatory=False)
		bld.logger = None

=== demos/fortran/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# DC 2008
# Thomas Nagy 2010 (ita)

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_fc')
	opt.load('compiler_c')
	opt.recurse('typemap')

def configure(conf):
	conf.load('compiler_c')
	conf.load('compiler_fc')

	if conf.env.FC_NAME == 'IFORT':
		conf.env.append_unique('FCFLAGS', '-warn')
	elif conf.env.FC_NAME == 'GFORTRAN':
		conf.env.append_unique('FCFLAGS', ['-Wall', '-W'])

	conf.check_fortran()
	conf.recurse('typemap')

def build(bld):

	bld(
		features = 'fc',
		source   = 'hello.f')

	bld(
		features = 'fc fcprogram',
		source   = 'hello.f',
		target   = 'hello',
		use      = 'DEBUG')

	bld(
		features = 'fc fcshlib',
		source   = 'foo.f',
		target   = 'shlib1',
		defs     = 'foo.def',
		vnum     = '2.3.9')

	bld(
		features = 'fc fcstlib',
		source   = 'foo.f',
		target   = 'foo')

	bld(
		features = 'fc fcprogram',
		source   = 'foo_pp.F',
		target   = 'foo',
		defines  = ['USEFOO', 'blah=1'],
		use      = 'shlib1')

	bld.add_group()

	bld(
		features = 'fc fcprogram',
		includes = 'src/include',
		source   = 'src/hello_inc.f',
		target   = 'hello_inc')

	bld(
		features = 'fc',
		source   = 'src/calculator_main.f src/calculator.f',
		target   = 'calc_objs')

	bld(
		features = 'fc fcprogram',
		use      = 'calc_objs',
		target   = 'calculator')

	bld(
		features = 'fc fcstlib',
		source = 'mod/two_mods.f90 mod/uses_two_mods.f90',
		target = 'mod/two_mods')

	bld.recurse('typemap')
	if bld.env.FC_NAME == 'GFORTRAN' and int(bld.env.FC_VERSION[0]) >= 6:
		bld.recurse('submodules')

=== demos/intltool/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

"""
help welcome to improve this demo folder
"""

APPNAME = 'app'

def configure(conf):
	conf.load('gnu_dirs intltool')

def build(bld):
	bld.recurse('data')
	bld(features='intltool_po', appname=APPNAME, podir='po', install_path="${LOCALEDIR}")

=== demos/lua/wscript ===
#! /usr/bin/env python
# coding: utf-8

def configure(conf):
	conf.load('lua')
	# to enable luac file installation globally:
	conf.env.LUADIR = '/opt/share/myapp/scripts/'

def build(bld):
	bld(source='foo.lua')

=== demos/python/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Gustavo Carneiro, 2007

import sys

VERSION='0.0.1'
APPNAME='python_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('python') # options for disabling pyc or pyo compilation
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')
	conf.load('python')
	conf.check_python_version((2,4,2))
	conf.check_python_headers()

	conf.check_python_module('os')
	conf.check_python_module('re', condition="ver > num(2,0,4) and ver <= num(2,3,0)")
	try:
		conf.check_python_module('pygccxml')
	except conf.errors.ConfigurationError:
		print('could not find pygccxml (ignored)')

def build(bld):

	# first compile a few pyc and pyo files (set install_path=None to disable the installation,
	# by default install_path is set to ${PYTHONDIR})
	bld(features='py', source=bld.path.ant_glob('*.py'), install_from='.')

	# example for generated python files
	target = bld.path.find_or_declare('abc.py')
	bld(rule='touch ${TGT}', source='wscript', target=target)
	bld(features='py', source=[target], install_from=target.parent)

	# then a c extension module
	bld(
		features = 'c cshlib pyext',
		source   = 'spammodule.c',
		target   = 'spam')

	# then a c program
	bld(
		features = 'c cprogram pyembed',
		source   = 'test.c',
		target   = 'test')

	# Install files keeping their directory structure (default: relative_trick=True)
	#
	# This will create:
	#   * lib/python2.7/site-packages/nested_scripts/foo/nested_foo.py
	bld(features='py',
		source=bld.path.ant_glob('nested_scripts/foo/*.py'),
		install_from='.')

	# Install files flatting the directory structure (relative_trick=False)
	#
	# This will create:
	#   * lib/python2.7/site-packages/nested_bar.py
	bld(features='py',
		source=bld.path.ant_glob('nested_scripts/bar/*.py'),
		relative_trick=False,
		install_from='.')

=== demos/qt5/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2016 (ita)
# Federico Pellegrin, 2019 (fedepell)

VERSION='0.0.1'
APPNAME='qt5_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx qt5 waf_unit_test')

def configure(conf):
	conf.load('compiler_cxx qt5 waf_unit_test')
	#conf.env.append_value('CXXFLAGS', ['-g']) # test

	if not conf.env.QT_LRELEASE:
		# While qt5 detects most Qt tools, most of them are optional
		conf.fatal('lrelease was not found')

	# These tests would run on Ubuntu but not on other platforms
	conf.check(
		define_name  = 'XYZ_QT5_TESTS',
		mandatory    = False,
		execute      = True,
		features     = 'qt5 cxx cxxprogram',
		includes     = '.',
		defines      = 'QT_WIDGETS_LIB',
		use          = 'QT5CORE QT5GUI QT5WIDGETS QT5TEST',
		msg          = 'Checking whether Qt5 tests can run',
		fragment     = '''
#include <QtTest/QtTest>
class TestQt5Test: public QObject {
        Q_OBJECT
        private:
                void testGui() {
			QWidget *widget = NULL;
			QTest::mouseClick(widget, Qt::LeftButton, Qt::NoModifier, QPoint(5,5), 0);
		}
};

QTEST_MAIN(TestQt5Test)
#include "test.moc"
''')

def build(bld):
	# According to the Qt5 documentation:
	#   Qt classes in foo.h   -> declare foo.h as a header to be processed by moc
	#			    add the resulting moc_foo.cpp to the source files
	#   Qt classes in foo.cpp -> include foo.moc at the end of foo.cpp
	#
	bld(
		features = 'qt5 cxx cxxprogram',
		use      = 'QT5CORE QT5GUI QT5SVG QT5WIDGETS',
		source   = 'main.cpp res.qrc but.ui foo.cpp',
		moc      = 'foo.h',
		target   = 'window',
		includes = '.',
		lang     = bld.path.ant_glob('linguist/*.ts'),
		langname = 'somefile', # include the .qm files from somefile.qrc
	)

	if bld.env.XYZ_QT5_TESTS:
		# Example of integration of Qt5 Unit tests using Qt5Test using waf_unit_test
		bld(
			features = 'qt5 cxx cxxprogram test',
			use      = 'QT5CORE QT5GUI QT5WIDGETS QT5TEST',
			defines  = 'QT_WIDGETS_LIB',
			source   = 'foo.cpp testqt5.cpp',
			moc      = 'foo.h',
			target   = 'footest',
			includes = '.',
			# ut_str   = './${SRC} -o test-report.xml,xunitxml', # put output to a xunit xml
		)

		bld.add_post_fun(print_test_results)	# print output of test runner to user


def print_test_results(bld):
	lst = getattr(bld, 'utest_results', [])
	if not lst:
		return
	for (f, code, out, err) in lst:
		print(out.decode('utf-8'))
		print(err.decode('utf-8'))

=== demos/subst/wscript ===
#! /usr/bin/env python
# encoding: utf-8

top = '.'
out = 'bin'

import os, re
from waflib import Utils

def configure(conf):
	pass

def build(bld):

	# the test.pc.in is a special case which is always handled
	bld(source='test.pc.in', VERSION='1.1', LIBS='moo', XPM_LIBS='-lxpm', LIBICONV='-liconv', XPM_CFLAGS='-O3', INTVAR=12)

	tg = bld(
		features     = 'subst', # the feature 'subst' overrides the source/target processing
		source       = 'foo.in', # list of string or nodes
		target       = 'foo.txt', # list of strings or nodes
		encoding     = 'ascii', # file encoding for python3, default is latin-1
		install_path = '/tmp/uff/', # installation path, optional
		chmod        = Utils.O755, # installation mode, optional
		PREFIX       = bld.env.PREFIX, # variables to use in the substitution
		re_m4        = re.compile('%%(\w+)%%', re.M), # custom substitution
		BINDIR       = bld.env.BINDIR)

	# if you are using an external dict, here is to merge the key/values:
	dct =  {'BINDIR': '/opt'}
	tg.__dict__.update(dct)

	# if you want a file copy, pass "is_copy=True"
	bld(features='subst', source='wscript', target='wscript', is_copy=True)

	# same thing with a simple function
	def fun(task, text):
		return text
	bld(features='subst', subst_fun=fun, source='wscript', target='wscript2')

	def hlink(task):
		try:
			link = os.link
		except AttributeError:
			task.outputs[0].write(task.inputs[0].read('rb'), 'wb')
		else:
			for x, y in zip(task.inputs, task.outputs):
				try:
					os.remove(y.abspath())
				except OSError:
					pass
				os.link(x.abspath(), y.abspath())
	bld(features='subst', fun=hlink, source='wscript', target='wscript3')

	# this one is just a reminder that simple files can be created (and a test too)
	bld(rule='echo "การไฟ่" > ${TGT}', target='uni.txt')

	# and this is an alternate syntax
	#@bld.rule(source='wscript', target='wscript2')
	#def _(tsk):
	#	tsk.outputs[0].write(tsk.inputs[0].read())

=== playground/boo/wscript ===
#! /usr/bin/env python

##
# This wscript shows the power of the CLI!
# You have an hello.exe using a world.dll,
# the world.dll can be generating using
# world.cs (in C#) or world.boo.

top = '.'
out = 'build'

def options(opt):
	opt.load('cs')
	opt.add_option("--use-cs", dest="use_cs", action="store_true",
		help="use world.cs to generate world.dll")

def configure(conf):
	conf.env.USE_CS = conf.options.use_cs
	if conf.env.USE_CS:
		conf.load('cs')
	conf.load('boo')

def build(bld):
	if bld.env.USE_CS:
		# C# world library
		bld(features = "cs",
			source   = "world.cs",
			type     = "library",
			gen      = "world.dll",
			name     = "world"
		)

	else:
		# boo world library
		bld(features = "boo",
			source   = "world.boo",
			type     = "library",
			gen      = "world.dll",
			name     = "world"
		)

	# executable that uses the world library
	bld(features = "boo",
		source   = "hello.boo",
		type     = "exe",
		gen      = "hello.exe",
		use      = "world"
	)

=== playground/boost/wscript ===
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_cxx boost')

def configure(conf):
    conf.load('compiler_cxx boost')
    conf.check_boost('system filesystem python', mt=True)

def build(bld):
    bld.program(source='main.cpp', target='app', use='BOOST')

=== playground/compress/wscript ===
#! /usr/bin/env python

"""
You will need either bzip2 or gzip, and a local waf copy
(unset the variable WAFDIR if set)

Using more than 100000 tasks may eat your memory
"""

top = '.'
out = 'build'

TEMPLATE = """
#! /usr/bin/gnuplot -persist
# output file, compression type, input file
set terminal png
set output "%s"
set ylabel "Amount of files created"
set xlabel "File size in kB"
set title "Compressed tar file distribution (%s)"
plot '%s' using 1:2 with lines lt 3 title ""
"""

import random, bz2, os, threading
lock = threading.Lock()

def options(opt):
	opt.add_option('--num', action='store', type='int', default=200, help='amount of compressed files to create')

# values for storing the min and max
gzip  = [10000000, 0]
bzip2 = [10000000, 0]
xz    = [10000000, 0]

def try_compress(self):
	global mi, ma

	frompath = self.generator.frompath

	uid = id(threading.current_thread())
	filename = frompath.abspath() + os.sep + 'test%d.bin' % uid

	self.files = self.generator.files[:]
	random.shuffle(self.files)

	if self.generator.kind == 'bzip2':
		store = bzip2
		cmd = 'cjf'
		ext = 'bz2'
	elif self.generator.kind == 'xz':
		store = xz
		cmd = 'cJf'
		ext = 'xz'
	else:
		store = gzip
		cmd = 'czf'
		ext = 'gz'

	self.generator.bld.exec_command('tar %s  %s  %s' % (cmd, filename, ' '.join(self.files)), cwd=frompath.abspath())

	siz = os.stat(filename).st_size
	if siz == 0:
		return -1

	try:
		lock.acquire()
		self.outputs[0].write('%d\n' % siz, 'a')

		if siz < store[0]:
			store[0] = siz
			os.rename(filename, self.generator.bld.bldnode.abspath() + os.sep + 'min%d.tar.%s' % (siz, ext))
		elif siz > store[1]:
			store[1] = siz
			os.rename(filename, self.generator.bld.bldnode.abspath() + os.sep + 'max%d.tar.%s' % (siz, ext))
		else:
			os.remove(filename)
	finally:
		lock.release()

def count_result(self):
	txt = self.inputs[0].read().strip()
	lst = txt.split()
	lst = [int(x) for x in lst if x]
	mi = min(lst)
	ma = max(lst)

	dc = {}
	for x in lst:
		try:
			dc[x] += 1
		except KeyError:
			dc[x] = 1

	nlst = ['%d %d' % (x, dc.get(x, 0)) for x in range(mi, ma+1)]
	self.outputs[0].write('\n'.join(nlst))

def write_template(self):
	t = self.generator.triplet
	self.outputs[0].write(TEMPLATE % (t[0].abspath(), t[1], t[2].abspath()))

def configure(conf):
	conf.find_program('gzip', mandatory=False)
	conf.find_program('bzip2', mandatory=False)
	if not conf.env.GZIP and not conf.env.BZIP2:
		conf.fatal('Either gzip or bzip2 is necessary for this')

	# xz is a gzip-like, lzma-based compression tool
	conf.find_program('xz', mandatory=False)

	conf.find_program('gnuplot', var='GNUPLOT')

def build(bld):
	wafdir_lst = bld.srcnode.ant_glob('.waf*', dir=True)
	if not wafdir_lst:
		bld.fatal('Missing local Waf directory')
	node = wafdir_lst[0]
	rels = [x.path_from(node) for x in node.ant_glob('**/*.py')]

	KINDS = []
	if bld.env.BZIP2:
		KINDS.append('bzip2')
	if bld.env.GZIP:
		KINDS.append('gzip')
	if bld.env.XZ:
		KINDS.append('xz')

	for kind in KINDS:
		p = bld.bldnode

		ini  = p.make_node('size_%s_1.txt' % kind)  # list of file sizes
		dist = p.make_node('size_%s_2.txt' % kind)  # distribution file (count the results)
		plot = p.make_node('size_%s_3.plot' % kind) # script file created for gnuplot
		png  = p.make_node('size_%s_4.png' % kind)  # picture created

		for x in range(bld.options.num):
			# the same target cannot have the signature of all the tasks that update it
			# so the tasks will be executed each time
			bld(rule=try_compress, target=ini, always=True, kind=kind, frompath=node, files=rels)

		# for the same reason, count_result will be executed each time
		bld(rule=count_result, target=dist, source=[ini], always=True)
		bld(rule=write_template, target=plot, triplet=[png, kind, dist], always=True)
		bld(rule='${GNUPLOT} < ${SRC[1].abspath()}', target=png, source=[dist, plot])

=== playground/cpp_gen/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

VERSION='0.0.1'
APPNAME='cpp_gen'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx')

def configure(conf):
	conf.load('compiler_cxx')
	conf.check(header_name='stdio.h', features='cxx cxxprogram', mandatory=False)

def build(bld):
	bld.program(source='main.cpp a.cpp', target='app')

#--------

import os
from waflib import Task, TaskGen, Utils
from waflib.Tools import cxx

@TaskGen.extension('.cpp')
def more_tasks_at_once(self, node):
   task1 = self.create_task('prog1', node, [])
   task2 = self.create_compiled_task('cxx', node)

def cmpnodes(a, b):
	return cmp(a.abspath(), b.abspath())

class prog1(Task.Task):
	before = ['cxxprogram', 'cxxshlib', 'cxxstlib']

	def uid(self):
		"""
		the unique id of this task should only depend on the file inputs
		"""
		m = Utils.md5()
		up = m.update
		up(self.__class__.__name__.encode())
		for x in self.inputs:
			up(x.abspath().encode())
		return m.digest()

	def runnable_status(self):
		"""
		since it is called after the build has started,
		any task added must be passed through 'more_tasks'
		"""
		for x in self.run_after:
			if not x.hasrun:
				return Task.ASK_LATER

		# so this is a bit special, the goal here is to set the output nodes
		# and to create the c++ tasks before the normal processing is done
		sig = self.signature()
		for x in self.generator.bld.raw_deps.get(sig, []):
			self.outputs.append(self.generator.bld.srcnode.find_node(x))

		if not self.outputs:
			self.read_outputs_from_cache()

		if self.outputs:
			self.create_cxx_task()

		ret = Task.Task.runnable_status(self)
		return ret

	def create_cxx_task(self):
		"""
		create a task dynamically during the build
		notice the use of 'more_tasks'
		"""
		tsk = cxx.cxx_hook(self.generator, self.outputs[0])
		tsk.set_run_after(self) # the build has started, so the order must be set manually
		self.more_tasks = [tsk] # add tasks dynamically during the build
		self.generator.link_task.inputs.append(tsk.outputs[0]) # add another input for the link task
		try:
			self.generator.link_task.inputs.sort(cmp=cmpnodes) # eliminate the random order (more tasks like this)
		except:
			self.generator.link_task.inputs.sort(key=lambda x: x.abspath()) # python3
		self.generator.link_task.set_run_after(tsk) # do not forget to set the build order there too

	def run(self):
		"""
		actual execution
		this code should not be executed if the files are retrieved from the cache
		"""
		if self.inputs[0].name == 'a.cpp':
			# simulate the creation of an interface file
			out = self.inputs[0].parent.get_bld().make_node('a.ser.cpp')
			out.write('\n\n')

		# read the file system
		# remember that nodes cannot be created concurrently
		# so you might to crate a lock if several tasks want the same nodes
		inp = self.inputs[0]
		node = inp.parent.get_bld().find_node(inp.name.replace('.cpp', '.ser.cpp'))
		if node:
			self.outputs = [node]
			h_node = inp.parent.find_node(inp.name.replace('.cpp', '.ser.h'))
			if h_node:
				self.outputs.append(h_node)

		# if there are outputs, create a new c++ task
		if self.outputs:
			self.create_cxx_task()

			# access the scanner data
			self.generator.bld.raw_deps[self.signature()] = [x.path_from(self.generator.bld.srcnode) for x in self.outputs]

	def read_outputs_from_cache(self):
		"""
		set the outputs from the results found in the cache
		we assume that the files are created in the same folder as the inputs
		if it is not like this, the nodes should be restored by another system, for example
		by storing them in a separate file during run()
		"""
		env = self.env
		sig = self.signature()
		ssig = Utils.to_hex(sig)

		# first try to access the cache folder for the task
		dname = os.path.join(self.generator.bld.cache_global, ssig)
		try:
			t1 = os.stat(dname).st_mtime
		except OSError:
			return None

		try:
			lst = os.listdir(dname)
		except:
			return

		for x in lst:
			self.outputs.append(self.inputs[0].parent.find_or_declare(x))

		# not a fresh build and the cache is removed -> remember the files in the scanner data
		self.generator.bld.raw_deps[self.signature()] = [x.path_from(self.generator.bld.srcnode) for x in self.outputs]

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=waf
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.0.25
pkgrel=2
pkgdesc="General-purpose build system modelled after Scons (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
license=('spdx:BSD-3-Clause')
url="https://waf.io/"
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
depends=("${MINGW_PACKAGE_PREFIX}-python")
options=('!emptydirs')
source=("https://waf.io/${_realname}-${pkgver}.tar.bz2"{,.asc}
        "0001-timeout-at-wait-after-kill.patch")
validpgpkeys=('8AF22DE5A06822E3474F3C7049B4C67C05277AAA'
              '0B3972B2D9E32EAB423D2E0F22BE0C62FFBFA548') # "Thomas Nagy <tnagy@waf.io>"
sha256sums=('66cff7beed0e77db874e9232cc08874abb3e866c7f0f1f34ba2f959fde44fdd4'
            'SKIP'
            '45239bbe8a12f6a0991ca9f4c6ddffb1b9f641199b6c5ab0d9abe038873f2b19')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  # Extract license
  head -n 30 waf-light | tail -n 25 > LICENSE

  apply_patch_with_msg \
    0001-timeout-at-wait-after-kill.patch
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  plain "Configure ..."
  ${MINGW_PREFIX}/bin/python ./waf-light configure --prefix=${MINGW_PREFIX}
  plain "Make waf ..."
  ${MINGW_PREFIX}/bin/python ./waf-light --make-waf
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"

  prelude=$(cat <<'EOF'
	import waflib.Tools.compiler_c, waflib.Tools.compiler_cxx
	waflib.Tools.compiler_c.c_compiler['win32'] = ['gcc', 'clang', 'msvc']
	waflib.Tools.compiler_cxx.cxx_compiler['win32'] = ['g++', 'clang++', 'msvc']
EOF
  )

  ${MINGW_PREFIX}/bin/python ./waf-light install -f --destdir="${pkgdir}" \
    --prelude="${prelude}" \
    --tools='compat,compat15,ocaml,go,cython,scala,erlang,cuda,gcj,boost,pep8,eclipse,unity,clang_compilation_database'

  install -Dm755 waf "${pkgdir}${MINGW_PREFIX}/bin/waf"
  install -Dm755 waf.bat "${pkgdir}${MINGW_PREFIX}/bin/waf.bat"

  # Force the generation of .waf.admin files
  cd "${srcdir}/${_realname}-${pkgver}/demos/c"
  CC_NAME=${CC} CC="${MINGW_PREFIX}/bin/${CC}.exe" \
  CXX_NAME=${CXX} CXX="${MINGW_PREFIX}/bin/${CXX}.exe" \
  "${pkgdir}${MINGW_PREFIX}/bin/waf" configure build

  # Fix weird directory placement (FS#38216, FS#38300)
  mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/waf"
  mv "${pkgdir}${MINGW_PREFIX}/bin/waf3-${pkgver}-"* "${pkgdir}${MINGW_PREFIX}/lib/waf/"
  sed -s "s|INSTALL=''|INSTALL='${MINGW_PREFIX}/lib/waf'|g" -i "${pkgdir}${MINGW_PREFIX}/bin/waf"

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
